#ifndef __DirectWindowLC_H__
#define __DirectWindowLC_H__

#include <OS.h>
#include <Locker.h>
#include <DirectWindow.h>
#include <String.h>

#include "frmwrk.h"

// window ////////////////////////////////////////////////////////////////////////////

class FrmDirectWindowLC : public BDirectWindow, public Framework
{
	BLocker				mFlipLock;
	area_id				mBitsArea;

	struct BUFFER_RECORD
	{
		uint8 *			bits;
		sem_id			writeLock;
		bool			unlockAtConnect;
	}
					   *mBack;
	uint8			   *mFrontBits;

	struct BUFFER_BITS_INFO
	{
		int32			bytes_per_row; 
		uint32			bits_per_pixel;
		color_space		pixel_format;
	}
						mFrontBitsInfo,
						mBackBitsInfo;

	struct BUFFER_CLIP_INFO
	{
		clipping_rect	window_bounds; 
		uint32			clip_list_count; 
		clipping_rect *	pclip_list;
	}
						mFrontClipInfo;

	int32				mFrameWidth;
	int32				mFrameHeight;

	int					mNumRingBufs;
	int					mDrawSelector;
	int					mFlipSelector;

	volatile bool		mConnected;

public:

	FrmDirectWindowLC(FrameworkParams &params, status_t &error, BString &errorString);
	~FrmDirectWindowLC();
		
	virtual void		MessageReceived(BMessage *message); 
	virtual void		DirectConnected(direct_buffer_info *info);
	virtual bool		QuitRequested();

	// interface methods to the drawing thread
	virtual status_t	frame_open(BUFFER_DESC &);
	virtual void	 	frame_close();
	// warning: above methods to be invoked from outside this window's thread,
	// 			thus using methods of this window from within the above takes
	//			locking this window's looper first!
};

#endif // __DirectWindowLC_H__
