#ifndef __null_h__
#define __null_h__

#include <Window.h>

#include "frmwrk.h"

// window /////////////////////////////////////////////////////////////////

class FrmNullWindow : public BWindow, public Framework
{
	sem_id				mDrawLock;

	int32				mFrameWidth;
	int32				mFrameHeight;
	int32				mBytesPerRow;

	area_id				mBitsArea;
	void *				mBits;

	color_space			mPixelFormat;

public:

	FrmNullWindow(FrameworkParams &params, status_t &error, BString &errorString);
	~FrmNullWindow();
		
	virtual void		WindowActivated(bool active);
	virtual bool		QuitRequested();

	// interface methods to the drawing thread
	virtual status_t	frame_open(BUFFER_DESC &);
	virtual void	 	frame_close();
	// warning: above methods to be invoked from outside this window's thread,
	// 			thus using methods of this window from within the above takes
	//			locking this window's looper first!
};

#endif //__null_h__
