#ifndef __WindowScreen_H__
#define __WindowScreen_H__

#include <OS.h>
#include <Locker.h>
#include <WindowScreen.h>
#include <Screen.h>
#include <String.h>

#include "frmwrk.h"

// window ////////////////////////////////////////////////////////////////////////////

class FrmWindowScreen : public BWindowScreen, public Framework
{
	BLocker				mDrawLock;
	BScreen *			mBScreen;

	int					mFlipSelector;
	int					mDrawSelector;

	struct BUFFER_RECORD
	{
		uint8 *			bits;
		sem_id			writeLock;
		bool			unlockAtConnect;
	}
					  * mBits;

	struct BUFFER_BITS_INFO
	{
		int32			bytes_per_row; 
		uint32			bits_per_pixel;
	}
						mBitsInfo;
	struct IPoint
	{
		int32			x;
		int32			y;
	}
						mClipFrame_upperLeft,
						mClipFrame_size,
						mScreen_size;

	volatile bool		mConnected;

	FrameworkParams &	mParams;
	status_t &			mError;
	BString	&			mErrorString;

	bigtime_t			mFlipTime;

	static uint32		MatchScreenSpace(BPoint &frameBounds, color_space color);

public:

	FrmWindowScreen(FrameworkParams &params, status_t &error, BString &errorString);
	~FrmWindowScreen();

	virtual void		MessageReceived(BMessage *message); 
	virtual void		ScreenConnected(bool connected);
	virtual bool		QuitRequested();

	// interface methods to the drawing thread
	virtual status_t	frame_open(BUFFER_DESC &);
	virtual void	 	frame_close();
	// warning: above methods to be invoked from outside this window's thread only!
};

#endif // __WindowScreen_H__
